/*
** out.c
** topsites out counter
** by Kevin Ferguson
** (c) 1999 Nethernet LLC
*/

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

#define MIN(a,b) (a)<(b)?(a):(b)
#define MAX 15
#define COOKIE_NAME "nethernet_topsites="
#define ACCOUNT_PATH "/home/warezlist/data/accounts/"
#define DEFAULT_URL "http://www.warezlist.com"

char pathinfo[256] = { 0 };
char cookie[256] = { 0 };
char pathfile[256] = { 0 };
char cookiefile[256] = { 0 };
char path[MAX][256] = { { 0 } };
int maxpath;
char cook[MAX][256] = { { 0 } };
int maxcook;
char buff[1024] = { 0 };

void split( int f ) {
  int i;
  char *p = buff, *q;

  read( f, p, 1023 );
  for( i = 0; i < MAX - 1; i++ ) {
    q = strstr( p, ";;;" );
    if( q==NULL ) break;
    memcpy( path[i], p, MIN( 255, q - p ) );
    p = q + 3;
  }
  strncpy( path[i], p, 255 );
  maxpath = i + 1;
}

/* bad code -- never do this! */
void split2( int f ) {
  int i;
  char *p = buff, *q;

  read( f, p, 1023 );
  for( i = 0; i < MAX - 1; i++ ) {
    q = strstr( p, ";;;" );
    if( q==NULL ) break;
    memcpy( cook[i], p, MIN( 255, q - p ) );
    p = q + 3;
  }
  strncpy( cook[i], p, 255 );
  maxcook = i + 1;
}

int main() {
  char *p ,*p2;
  int l;
  int pf, cf, ok = 0;
  int i;
  unsigned int n;
  printf("Content-type: text/html\n\n");
  if( getenv( "PATH_INFO" ) != NULL ) strncpy( pathinfo, getenv( "PATH_INFO" ) + 1, 255 );
  if( getenv( "HTTP_COOKIE" ) != NULL ) {
    if( (p = strstr( getenv( "HTTP_COOKIE" ), COOKIE_NAME )) != NULL ) {
      p += strlen( COOKIE_NAME );
      if( (p2 = index( p, ';' ))==NULL ) p2 = index( p, 0 );
      l = p2 - p;
      if( l > 255 ) l = 255;
      memcpy( cookie, p, l );
      printf("Cookie: %s",cookie);
    }
  }
  
  strncpy( pathfile, ACCOUNT_PATH, 255 );
  strncat( pathfile, pathinfo, 255 - strlen( pathfile ) );
  strncat( pathfile, ".txt", 255 - strlen( pathfile ) );
  strncpy( cookiefile, ACCOUNT_PATH, 255 );
  strncat( cookiefile, cookie, 255 - strlen( cookiefile ) );
  strncat( cookiefile, ".txt", 255 - strlen( cookiefile ) );

  if( strlen( pathinfo ) ) {
    if( (pf = open( pathfile, O_RDONLY )) >= 0 ) {
      flock( pf, LOCK_EX );
      split( pf );
      flock( pf, LOCK_UN );
      close( pf );
      printf( "Location: %s\n\n", path[3] );
      ok = 1;
    }
    n = atoi( path[10] );
    n++;
    snprintf( path[10], 255, "%d", n );
    n = atoi( path[11] );
    n++;
    snprintf( path[11], 255, "%d", n );
    
    if( (pf = open( pathfile, O_WRONLY )) >= 0 ) {
      flock( pf, LOCK_EX );
      for( i = 0; i < maxpath - 1; i++ ) {
	write( pf, path[i], strlen( path[i] ) );
	write( pf, ";;;", 3 );
      }
      write( pf, path[maxpath - 1], strlen( path[maxpath - 1] ) );
      flock( pf, LOCK_UN );
      close( pf );
    }
  }

  if( strlen( cookie ) ) {
    if( (cf = open( cookiefile, O_RDONLY )) >= 0 ) {
      flock( cf, LOCK_EX );
      split2( cf );
      flock( cf, LOCK_UN );
      close( cf );
    }
    n = atoi( cook[0] );
    n++;

    snprintf( cook[0], 255, "%d", n );
    printf("Cookie [0]: %s",cook[0]);
    n = atoi( cook[12] );
    n++;
    snprintf( cook[12], 255, "%d", n );
    printf("Cookie [12]: %s",cook[12]);

    if( (pf = open( cookiefile, O_WRONLY )) >= 0 ) {
      flock( pf, LOCK_EX );
      for( i = 0; i < maxcook - 1; i++ ) {
	write( pf, cook[i], strlen( cook[i] ) );
	write( pf, ";;;", 3 );
      }
      write( pf, cook[maxcook - 1], strlen( cook[maxcook - 1] ) );
      flock( pf, LOCK_UN );
      close( pf );
    }
  }

  if( !ok ) printf( "Location: %s\n\n", DEFAULT_URL );

  return 0;
}
